//+------------------------------------------------------------------+
//|                                    FXI_True_Range_Volatility.mq4 |
//|                        Copyright  2007, Sharptrade Partners LLC |
//|                                              http://FXIMPACT.COM |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Sharptrade Partners LLC"
#property link      "http://FXIMPACT.COM"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DarkKhaki
#property indicator_color2 MediumSlateBlue
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

extern int AvgPeriod = 4;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int alpha = Bars-1;
   
   for(int i = Bars-2; i >= 0; i--)
   {
      if(Bars != counted_bars)
      {
         if((alpha-i) <= 200)
         {
            ExtMapBuffer1[i] = iATR(NULL, 0, alpha-i, 0);
         }
         else
         {
            ExtMapBuffer1[i] = iATR(NULL, 0, 200, 0);
         }
      
         if((alpha-i) <= AvgPeriod)
         {
            ExtMapBuffer2[i] = iATR(NULL, 0, alpha-i, i+1);
         }
         else
         {
            ExtMapBuffer2[i] = iATR(NULL, 0, AvgPeriod, i+1);
         }
      }
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+